Index: sys/kern/syscalls.master
===================================================================
--- sys/kern/syscalls.master	(revision 379)
+++ sys/kern/syscalls.master	(revision 781)
@@ -870,6 +870,22 @@
 488	AUE_NULL	STD	{ int cpuset_setaffinity(cpulevel_t level, \
 				    cpuwhich_t which, id_t id, size_t cpusetsize, \
 				    const cpuset_t *mask); }
-
+489     AUE_NULL        STD     { int sys_set_dimetrodon_constant(int value); }
+490	AUE_NULL	STD	{ int sys_dimetrodon_set_idle_ticks(int ticks); }
+491     AUE_NULL        STD     { int sys_dimetrodon_set_min_preempt(int min); }
+492	AUE_NULL	STD	{ int sys_dimetrodon_set_heuristic(int which); }
+493	AUE_NULL	STD	{ u_long sys_dimetrodon_get_stats(int which); }
+494	AUE_NULL	STD	{ int sys_dimetrodon_set_nopreempt(void); }
+495	AUE_NULL	STD	{ int sys_dimetrodon_set_dopreempt(void); }
+496	AUE_NULL	STD	{ int sys_dimetrodon_set_doregular(void); }
+497	AUE_NULL	STD	{ int sys_dimetrodon_set_nopreempt_specify(int which); }
+498	AUE_NULL	STD	{ int sys_dimetrodon_set_dopreempt_specify(int which); }
+499	AUE_NULL	STD	{ int sys_dimetrodon_set_idletime_kind(int which); }
+500	AUE_NULL	STD	{ int sys_dimetrodon_set_min_idle_ticks(int which); }
+501	AUE_NULL	STD	{ int sys_dimetrodon_get_avg_quanta(int which); }
+502	AUE_NULL	STD	{ int sys_dimetrodon_reset_quanta_count(int which); }
+503	AUE_NULL	STD	{ int sys_dimetrodon_anoint_thread_specify(int which); }
+504	AUE_NULL	STD	{ int sys_dimetrodon_unanoint_thread_specify(int which); }
+505	AUE_NULL	STD	{ int sys_dimetrodon_is_thread_anointed(int which); }
 ; Please copy any additions and changes to the following compatability tables:
 ; sys/compat/freebsd32/syscalls.master
Index: sys/kern/systrace_args.c
===================================================================
--- sys/kern/systrace_args.c	(revision 379)
+++ sys/kern/systrace_args.c	(revision 781)
@@ -2936,6 +2936,119 @@
 		*n_args = 5;
 		break;
 	}
+	/* sys_set_dimetrodon_constant */
+	case 489: {
+		struct sys_set_dimetrodon_constant_args *p = params;
+		iarg[0] = p->value; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_set_idle_ticks */
+	case 490: {
+		struct sys_dimetrodon_set_idle_ticks_args *p = params;
+		iarg[0] = p->ticks; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_set_min_preempt */
+	case 491: {
+		struct sys_dimetrodon_set_min_preempt_args *p = params;
+		iarg[0] = p->min; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_set_heuristic */
+	case 492: {
+		struct sys_dimetrodon_set_heuristic_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_get_stats */
+	case 493: {
+		struct sys_dimetrodon_get_stats_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_set_nopreempt */
+	case 494: {
+		*n_args = 0;
+		break;
+	}
+	/* sys_dimetrodon_set_dopreempt */
+	case 495: {
+		*n_args = 0;
+		break;
+	}
+	/* sys_dimetrodon_set_doregular */
+	case 496: {
+		*n_args = 0;
+		break;
+	}
+	/* sys_dimetrodon_set_nopreempt_specify */
+	case 497: {
+		struct sys_dimetrodon_set_nopreempt_specify_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_set_dopreempt_specify */
+	case 498: {
+		struct sys_dimetrodon_set_dopreempt_specify_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_set_idletime_kind */
+	case 499: {
+		struct sys_dimetrodon_set_idletime_kind_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_set_min_idle_ticks */
+	case 500: {
+		struct sys_dimetrodon_set_min_idle_ticks_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_get_avg_quanta */
+	case 501: {
+		struct sys_dimetrodon_get_avg_quanta_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_reset_quanta_count */
+	case 502: {
+		struct sys_dimetrodon_reset_quanta_count_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_anoint_thread_specify */
+	case 503: {
+		struct sys_dimetrodon_anoint_thread_specify_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_unanoint_thread_specify */
+	case 504: {
+		struct sys_dimetrodon_unanoint_thread_specify_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
+	/* sys_dimetrodon_is_thread_anointed */
+	case 505: {
+		struct sys_dimetrodon_is_thread_anointed_args *p = params;
+		iarg[0] = p->which; /* int */
+		*n_args = 1;
+		break;
+	}
 	default:
 		*n_args = 0;
 		break;
@@ -4489,6 +4602,16 @@
 			break;
 		};
 		break;
+	/* setfib */
+	case 175:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
 	/* ntp_adjtime */
 	case 176:
 		switch(ndx) {
@@ -7652,6 +7775,244 @@
 			break;
 		};
 		break;
+	/* cpuset */
+	case 484:
+		switch(ndx) {
+		case 0:
+			p = "cpusetid_t *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cpuset_setid */
+	case 485:
+		switch(ndx) {
+		case 0:
+			p = "cpuwhich_t";
+			break;
+		case 1:
+			p = "id_t";
+			break;
+		case 2:
+			p = "cpusetid_t";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cpuset_getid */
+	case 486:
+		switch(ndx) {
+		case 0:
+			p = "cpulevel_t";
+			break;
+		case 1:
+			p = "cpuwhich_t";
+			break;
+		case 2:
+			p = "id_t";
+			break;
+		case 3:
+			p = "cpusetid_t *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cpuset_getaffinity */
+	case 487:
+		switch(ndx) {
+		case 0:
+			p = "cpulevel_t";
+			break;
+		case 1:
+			p = "cpuwhich_t";
+			break;
+		case 2:
+			p = "id_t";
+			break;
+		case 3:
+			p = "size_t";
+			break;
+		case 4:
+			p = "cpuset_t *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* cpuset_setaffinity */
+	case 488:
+		switch(ndx) {
+		case 0:
+			p = "cpulevel_t";
+			break;
+		case 1:
+			p = "cpuwhich_t";
+			break;
+		case 2:
+			p = "id_t";
+			break;
+		case 3:
+			p = "size_t";
+			break;
+		case 4:
+			p = "const cpuset_t *";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_set_dimetrodon_constant */
+	case 489:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_set_idle_ticks */
+	case 490:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_set_min_preempt */
+	case 491:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_set_heuristic */
+	case 492:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_get_stats */
+	case 493:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_set_nopreempt */
+	case 494:
+		break;
+	/* sys_dimetrodon_set_dopreempt */
+	case 495:
+		break;
+	/* sys_dimetrodon_set_doregular */
+	case 496:
+		break;
+	/* sys_dimetrodon_set_nopreempt_specify */
+	case 497:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_set_dopreempt_specify */
+	case 498:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_set_idletime_kind */
+	case 499:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_set_min_idle_ticks */
+	case 500:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_get_avg_quanta */
+	case 501:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_reset_quanta_count */
+	case 502:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_anoint_thread_specify */
+	case 503:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_unanoint_thread_specify */
+	case 504:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
+	/* sys_dimetrodon_is_thread_anointed */
+	case 505:
+		switch(ndx) {
+		case 0:
+			p = "int";
+			break;
+		default:
+			break;
+		};
+		break;
 	default:
 		break;
 	};
Index: sys/kern/sched_heuristics.c
===================================================================
--- sys/kern/sched_heuristics.c	(revision 0)
+++ sys/kern/sched_heuristics.c	(revision 781)
@@ -0,0 +1,391 @@
+ /*
+ * Power-Conserving Interactive-User-Sensitive Scheduling (DIMETRODON) Heuristics
+ *
+ *  Copyright (C) 2009 Peter Bailis, Sanjay Gandhi.
+ */
+
+/*
+These includes are indeed overkill, but it appears that BSD is a bit more picky
+about include order, etc, than linux, and makekernel is going nuts over
+includes, so we're going to copy sched_4bsd.h and add some...
+
+Eventually, these should be pruned down, but for now, leave them.
+ */
+#include <sys/cdefs.h>
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/cpuset.h>
+#include <sys/kernel.h>
+#include <sys/ktr.h>
+#include <sys/kthread.h>
+#include <sys/proc.h>
+#include <sys/resourcevar.h>
+#include <sys/sched.h>
+#include <sys/sysproto.h>
+#include <sys/syscall.h>
+#include <sys/smp.h>
+#include <sys/sysctl.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/sx.h>
+#include <sys/umtx.h>
+#include <sys/libkern.h>
+#include <sys/sched_heuristics.h>
+#include <machine/smp.h>
+
+#ifdef KTRACE
+#include <sys/ktrace.h>
+#endif
+
+unsigned idle_count = 0;
+unsigned real_count = 0;
+
+static unsigned heuristic_constant = MAX_HEURISTIC_CONSTANT;
+static int ticks_to_preempt = DEFAULT_MIN_TICKS_TO_PREEMPT*2;
+
+int dimetrodon_idle_ticks = DEFAULT_DIMETRODON_IDLE_TICKS;
+
+int chosen_heuristic = SIMPLE_CONSTANT_WITH_MINTICKS;
+
+int dimetrodon_min_idle_ticks = DEFAULT_MIN_IDLETIME;
+int dimetrodon_chosen_idletime_kind = IDLETIME_SET_TICKS;
+
+static int calculate_heuristic(struct thread *td);
+
+void increment_idle_count(void)
+{
+	++idle_count;
+}
+
+void increment_real_count_cond(void)
+{
+	++real_count;
+}
+
+int sys_dimetrodon_get_stats(struct thread *td, struct sys_dimetrodon_get_stats_args *pa)
+{
+	if(pa->which <= 0)
+		td->td_retval[0] = idle_count;
+	else
+	{
+		td->td_retval[0] = real_count;
+	}
+
+	return 0;
+}
+
+int sys_dimetrodon_set_min_preempt(struct thread *td,
+			       struct sys_dimetrodon_set_min_preempt_args *pa)
+{
+	int newmin = pa->min;
+
+	if(newmin < 0)
+		return -1;
+
+	td->td_retval[0] = newmin;
+	ticks_to_preempt = newmin*2;
+
+	return 0;
+}
+
+int sys_dimetrodon_set_heuristic(struct thread *td,
+			     struct sys_dimetrodon_set_heuristic_args *pa)
+{
+	if(pa->which < 0 || pa->which > MAX_HEURISTIC)
+		return -1;
+
+	chosen_heuristic = pa->which;
+
+	return 0;
+}
+
+int sys_dimetrodon_set_idletime_kind(struct thread *td,
+				     struct sys_dimetrodon_set_idletime_kind_args *pa)
+{
+	if(pa->which != IDLETIME_RECENT_TIME && pa->which != IDLETIME_SET_TICKS)
+		return -1;
+
+	dimetrodon_chosen_idletime_kind = pa->which;
+
+	return 0;
+}
+
+
+int sys_dimetrodon_set_nopreempt(struct thread *td, struct sys_dimetrodon_set_nopreempt_args *pa)
+{
+	td->td_proc->dimetrodon_always_preempt = -1;
+
+	return 0;
+}
+
+int sys_dimetrodon_set_dopreempt(struct thread *td, struct sys_dimetrodon_set_dopreempt_args *pa)
+{
+	td->td_proc->dimetrodon_always_preempt = 1;
+
+	return 0;
+}
+
+int sys_dimetrodon_set_nopreempt_specify(struct thread *td, struct sys_dimetrodon_set_nopreempt_specify_args *pa)
+{
+        struct proc *current = pfind(pa->which);
+
+        if(current == 0)
+        {
+                return -1;
+        }
+
+        current->dimetrodon_always_preempt = -1;
+
+        PROC_UNLOCK(current);
+
+	td->td_retval[0] = pa->which;
+
+        return 0;
+}
+
+int sys_dimetrodon_set_dopreempt_specify(struct thread *td, struct sys_dimetrodon_set_dopreempt_specify_args *pa)
+{
+        struct proc *current = pfind(pa->which);
+
+        if(current == 0)
+        {
+                return -1;
+        }
+
+        current->dimetrodon_always_preempt = 1;
+
+        PROC_UNLOCK(current);
+
+	td->td_retval[0] = pa->which;
+
+        return 0;
+}
+
+int sys_dimetrodon_anoint_thread_specify(struct thread *td, struct sys_dimetrodon_anoint_thread_specify_args *pa)
+{
+        struct proc *current = pfind(pa->which);
+
+        if(current == 0)
+        {
+                return -1;
+        }
+
+        current->is_dimetrodon_anointed = 1;
+
+        PROC_UNLOCK(current);
+
+	td->td_retval[0] = pa->which;
+
+        return 0;
+}
+
+int sys_dimetrodon_unanoint_thread_specify(struct thread *td, struct sys_dimetrodon_unanoint_thread_specify_args *pa)
+{
+        struct proc *current = pfind(pa->which);
+
+        if(current == 0)
+        {
+                return -1;
+        }
+
+        current->is_dimetrodon_anointed = 0;
+
+        PROC_UNLOCK(current);
+
+	td->td_retval[0] = pa->which;
+
+        return 0;
+}
+
+int sys_dimetrodon_is_thread_anointed(struct thread *td, struct sys_dimetrodon_is_thread_anointed_args *pa)
+{
+        struct proc *current = pfind(pa->which);
+
+        if(current == 0)
+        {
+                return -1;
+        }
+
+        if(current->is_dimetrodon_anointed)
+	{
+		td->td_retval[0] = 1;
+	}
+	else
+	{
+		td->td_retval[0] = -1;
+	}
+
+        PROC_UNLOCK(current);
+
+        return 0;
+}
+
+int sys_dimetrodon_get_avg_quanta(struct thread *td, struct sys_dimetrodon_get_avg_quanta_args *pa)
+{
+        struct proc *current = pfind(pa->which);
+        if(current == 0)
+        {
+                return -1;
+        }
+
+	mtx_lock_spin(&current->tick_lock);
+
+	if(current->proc_numquanta == 0)
+	{
+	    td->td_retval[0] = -1;
+	}
+	else
+	{
+	    td->td_retval[0] = (current->proc_ticks)/
+	      (current->proc_numquanta);
+	}
+
+	mtx_unlock_spin(&current->tick_lock);
+
+        PROC_UNLOCK(current);
+
+
+        return 0;
+}
+
+int sys_dimetrodon_reset_quanta_count(struct thread *td, struct sys_dimetrodon_reset_quanta_count_args *pa)
+{
+        struct proc *current = pfind(pa->which);
+        if(current == 0)
+        {
+                return -1;
+        }
+
+	mtx_lock_spin(&current->tick_lock);
+
+	current->proc_ticks = 0;
+	current->proc_numquanta = 0;
+
+	mtx_unlock_spin(&current->tick_lock);
+
+        PROC_UNLOCK(current);
+
+	td->td_retval[0] = pa->which;
+
+        return 0;
+}
+
+int sys_dimetrodon_set_doregular(struct thread *td, struct sys_dimetrodon_set_doregular_args *pa)
+{
+	td->td_proc->dimetrodon_always_preempt = 0;
+	return 0;
+}
+
+int sys_dimetrodon_set_idle_ticks(struct thread *td,
+			      struct sys_dimetrodon_set_idle_ticks_args *pa)
+{
+	int newticks = pa->ticks;
+
+	if(newticks < 0)
+		return -1;
+
+	td->td_retval[0] = newticks;
+	dimetrodon_idle_ticks = newticks;
+
+	return 0;
+}
+
+int sys_dimetrodon_set_min_idle_ticks(struct thread *td,
+				      struct sys_dimetrodon_set_min_idle_ticks_args *pa)
+{
+	int newticks = pa->which;
+
+	if(newticks < 0)
+		return -1;
+
+	td->td_retval[0] = newticks;
+	dimetrodon_min_idle_ticks = newticks;
+
+	return 0;
+}
+
+
+int sys_set_dimetrodon_constant(struct thread *td,
+			    struct sys_set_dimetrodon_constant_args *pa)
+{
+	set_heuristic_constant(pa->value);
+	td->td_retval[0] = heuristic_constant;	
+	
+	return 0;
+}
+
+//technically we should synchronize this, but it doesn't really matter
+int set_heuristic_constant(int new)
+{
+	new *= 10;
+
+	if(new < 0 || new > MAX_HEURISTIC_CONSTANT)
+	{
+		return -1;
+	}
+
+	CTR1(KTR_SCHED, "set_heuristic_constant: setting constant to %u",
+	     new);
+
+	heuristic_constant = new;
+
+	return new;
+}
+
+static int thread_has_minticks(struct thread *td)
+{
+	//make sure we aren't going to preempt a short-running process
+	if((td->td_recenttick_old + td->td_recenttick_new) < ticks_to_preempt)
+	{
+		CTR4(KTR_SCHED, "do_schedule_now: %p(%s) too few recentticks: %d (min %d)",
+		     td, td->td_proc->p_comm, (td->td_recenttick_old+td->td_recenttick_new)/2, ticks_to_preempt);
+
+		return 0;
+	}
+
+	return 1;
+}
+
+static int simple_constant_heuristic(struct thread *td)
+{
+	return heuristic_constant;
+}
+
+static int calculate_heuristic(struct thread *td)
+{
+	if(td->td_proc->dimetrodon_always_preempt == -1)
+		return MAX_HEURISTIC_CONSTANT;
+	else if(td->td_proc->dimetrodon_always_preempt == 1)
+		return heuristic_constant;
+
+	switch(chosen_heuristic)
+	{
+	case SIMPLE_CONSTANT:
+		return simple_constant_heuristic(td);
+	case SIMPLE_CONSTANT_WITH_MINTICKS:
+		return thread_has_minticks(td) ? simple_constant_heuristic(td)
+			: MAX_HEURISTIC_CONSTANT;
+	case NONE:
+	default:
+		return MAX_HEURISTIC_CONSTANT;
+	}
+}
+
+int do_schedule_now(struct thread *td)
+{
+	KASSERT(!TD_IS_IDLETHREAD(td), "do_schedule_now idlethread?");
+
+	//don't preempt kernel threads
+	if(td->td_priority < PRI_MIN_TIMESHARE)
+	{
+		return 1;
+	}
+
+	int heuristic_value = calculate_heuristic(td);
+
+	if(heuristic_value >= MAX_HEURISTIC_CONSTANT)
+		return 1;
+
+	return ((random() % MAX_HEURISTIC_VALUE) < heuristic_value) ? 1 : 0;
+}
+
Index: sys/dev/acpica/acpi_cpu.c
===================================================================
--- sys/dev/acpica/acpi_cpu.c	(revision 379)
+++ sys/dev/acpica/acpi_cpu.c	(revision 781)
@@ -40,7 +40,7 @@
 #include <sys/proc.h>
 #include <sys/sbuf.h>
 #include <sys/smp.h>
-
+#include <sys/sched_heuristics.h>
 #include <dev/pci/pcivar.h>
 #include <machine/atomic.h>
 #include <machine/bus.h>
@@ -164,6 +164,8 @@
 static int	acpi_cpu_set_cx_lowest(struct acpi_cpu_softc *sc, int val);
 static int	acpi_cpu_cx_lowest_sysctl(SYSCTL_HANDLER_ARGS);
 static int	acpi_cpu_global_cx_lowest_sysctl(SYSCTL_HANDLER_ARGS);
+static void acpi_cpu_c2(void);
+static uint32_t get_trans_lat(unsigned num);
 
 static device_method_t acpi_cpu_methods[] = {
     /* Device interface */
@@ -1191,3 +1193,24 @@
 
     return (0);
 }
+
+static void acpi_cpu_c2(void)
+{
+	struct acpi_cpu_softc *sc;
+	sc = cpu_softc[PCPU_GET(cpuid)];
+	
+	CPU_GET_REG(sc->cpu_cx_states[2].p_lvlx, 1);	
+}
+
+static uint32_t get_trans_lat(unsigned num)
+{
+	struct acpi_cpu_softc *sc;
+
+	if(num >= MAX_CX_STATES)
+	{
+		return 0;
+	}
+	
+	sc = cpu_softc[PCPU_GET(cpuid)];
+	return sc->cpu_cx_states[num].trans_lat;
+}
